## kubernetes 1.5.5+dfsg

=== test/images/serve_hostname/Makefile ===
# Copyright 2016 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Cross-build the serve_hostname image
#
# Usage:
#       [TAG=v1.5] [PREFIX=gcr.io/google_containers] [TEST_REGISTRY=gcr.io/k8s-authenticated-test] [ARCH=amd64] [BASEIMAGE=busybox] make all

.PHONY: all push container clean

TAG ?= v1.5

REGISTRY ?= gcr.io/google-containers
TEST_REGISTRY ?= gcr.io/k8s-authenticated-test

# Architectures supported: amd64, arm, arm64 and ppc64le
ARCH ?= amd64

ALL_ARCH = amd64 arm arm64 ppc64le

GOARM=6
TEMP_DIR := $(shell mktemp -d)
GOLANG_VERSION = 1.6.3

BIN = serve_hostname
SRCS = serve_hostname.go

IMAGE = $(REGISTRY)/$(BIN)-$(ARCH)
TEST_IMAGE = $(TEST_REGISTRY)/$(BIN)-$(ARCH)

# Set default base image dynamically for each arch
ifeq ($(ARCH),amd64)
        BASEIMAGE?=busybox
endif
ifeq ($(ARCH),arm)
        BASEIMAGE?=armel/busybox
endif
ifeq ($(ARCH),arm64)
        BASEIMAGE?=aarch64/busybox
endif
ifeq ($(ARCH),ppc64le)
        BASEIMAGE?=ppc64le/busybox
endif

# If you want to build AND push all containers, see the 'all-push' rule.
all: all-container

sub-container-%:
	$(MAKE) ARCH=$* container

sub-push-%:
	$(MAKE) ARCH=$* push

all-container: $(addprefix sub-container-,$(ALL_ARCH))

all-push: $(addprefix sub-push-,$(ALL_ARCH))

build: bin/$(BIN)-$(ARCH)

bin/$(BIN)-$(ARCH): $(SRCS)
	# Copy the content in this dir to the temp dir
	cp ./* $(TEMP_DIR)

	docker run -it -v $(TEMP_DIR):/build \
	golang:$(GOLANG_VERSION) \
	/bin/bash -c "\
            cd /build && \
            CGO_ENABLED=0 GOARM=$(GOARM) GOARCH=$(ARCH) go build -a -installsuffix cgo --ldflags '-w' -o $(BIN) ./$(SRCS)"

container: .container-$(ARCH)
.container-$(ARCH): bin/$(BIN)-$(ARCH)
	# Set the base image
	cd $(TEMP_DIR) && sed -i.bak 's|BASEIMAGE|$(BASEIMAGE)|g' Dockerfile

	docker build --pull -t $(IMAGE):$(TAG) $(TEMP_DIR)
	if [ -n "$(TEST_REGISTRY)" ]; then \
		docker tag $(IMAGE):$(TAG) $(TEST_IMAGE):$(TAG) ;\
	fi

push: .push-$(ARCH)
.push-$(ARCH): .container-$(ARCH)
	gcloud docker -- push $(IMAGE):$(TAG)
	if [ -n "$(TEST_REGISTRY)" ]; then \
		gcloud docker -- push $(TEST_IMAGE):$(TAG) ;\
	fi

clean:
	rm -rf $(BIN)

=== cluster/addons/fluentd-gcp/fluentd-gcp-image/Makefile ===
# Copyright 2016 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# The build rule builds a Docker image that logs all Docker contains logs to
# Google Compute Platform using the Cloud Logging API. The push rule pushes
# the image to DockerHub.

# Procedure for change:
# 1. Bump the tag number.
# 2. Create an image for the kubernetes user on Dockerhub and push there: make kbuild kpush
# 3. Temporarily adjust any config files etc. that reference gcr.io/google_containers/fluentd-gcp:$(TAG)
#    to use kubernetes/fluentd-gcp:$(TAG) instead.
# 4. Test etc.
# 5. Issue PR.
# 6. When PR is approved make the gcr.io version of the image: make build push
# 7. Revert the referendes to kubernetes/fluentd-gcp:$(TAG) to gcr.io/google_containers/fluentd-gcp:$(TAG)

.PHONY:	build push

PREFIX=gcr.io/google_containers
TAG = 1.28.2

build:
	docker build --pull -t $(PREFIX)/fluentd-gcp:$(TAG) .


push:
	gcloud docker -- push $(PREFIX)/fluentd-gcp:$(TAG)

## kubernetes 1.0

=== debian/changelog ===
kubernetes (1.0) cosmic; urgency=medium

  * Initial Packaging Release. (LP: #1780334)

 -- Adam Stokes <adam.stokes@ubuntu.com>  Mon, 27 Aug 2018 09:31:00 -0400

=== debian/control ===
Source: kubernetes
Section: misc
Priority: optional
Maintainer: Adam Stokes <adam.stokes@ubuntu.com>
Build-Depends: debhelper (>=11)
Standards-Version: 4.1.4
Homepage: https://k8s.io

Package: kubernetes
Architecture: all
Depends: ${misc:Depends}
Description: Installer package for Kubernetes
 Kubernetes is an open-source system for automating deployment, scaling, and
 management of containerized applications.

## kubernetes 1.5.5+dfsg

=== debian/changelog ===
kubernetes (1.5.5+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Don't build on ppc64le due to Go linker problems. See GitHub issue
    https://github.com/golang/go/issues/15823.
  * Don't build on ppc64 as it's not supported by upstream at the
    moment. (Closes: #860505)

 -- Tim Potter <tpot@hpe.com>  Sat, 03 Jun 2017 08:00:51 +1000

kubernetes (1.5.5+dfsg-1) unstable; urgency=low

  [ Dmitry Smirnov ]
  * Switch to bundled "rkt".
  * rules: remove "-p" option from build and test overrides.
  * control: drop obsolete "golang-clockwork-dev" alternative.
  * New patch to disable test failing on [armel].
  * Upload to unstable.

  [ Tim Potter ]
  * New upstream version. [March 2017]
  * Big updates to d/rules and d/copyright to update to upstream
    changes made since the 1.2.x release.
  * Refresh patches to bring up to date with upstream changes since
    1.2.x.
  * control: add lsb-base as dependency for sysvinit scripts.
  * Suppress spelling-error-in-binary Lintian messages.

 -- Tim Potter <tpot@hpe.com>  Thu, 13 Apr 2017 16:45:57 +1000

kubernetes (1.2.5+dfsg-1) experimental; urgency=medium

  * New upstream release [June 2016].
  * Switch to private "github.com/golang/glog" due to log noise.
  * Disabled failing tests; no longer ignore failures in tests.
  * Build/test using 2 cores only.
  * New patch to update appc/cni name space (fixes FTBFS).
  * Removed obsolete "spf13-cobra.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 03 Jul 2016 04:12:28 +1000

kubernetes (1.2.4+dfsg-2) experimental; urgency=medium

  * Added new patch to fix incompatibility with "imdario/mergo" v0.2.2
    (Closes: #825753).
    Thanks, Florian Ernst.
  * Enable tests but ignore failures for now.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 17 Jun 2016 01:41:38 +1000

kubernetes (1.2.4+dfsg-1) experimental; urgency=medium

  * New upstream release [May 2016].
  * New patch to print output of "uname -m" on unsupported architectures.
  * New "docker.patch" to fix potential FTBFS.
    + Build-Depends += "golang-github-docker-distribution-dev".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 15 Jun 2016 21:03:01 +1000

kubernetes (1.2.3+dfsg-1) experimental; urgency=low

  * Initial release (Closes: #795652).

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 25 Apr 2016 22:40:12 +1000

=== debian/control ===
Source: kubernetes
Section: admin
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Build-Depends: debhelper (>=9), bash-completion, dh-golang, dh-systemd
        ,golang-go
        ,go-bindata (>= 3.0.7~)
        ,go-md2man (>= 1.0.1~)
	,libseccomp-dev
	,golang-github-spf13-pflag-dev
	,golang-github-spf13-viper-dev
	,golang-github-spf13-cast-dev
	,golang-github-spf13-cobra-dev
	,golang-github-spf13-afero-dev
	,golang-github-spf13-jwalterweatherman-dev
	,golang-github-davecgh-go-spew-dev
	,golang-github-blang-semver-dev
	,golang-github-go-openapi-spec-dev
	,golang-github-go-openapi-swag-dev
	,golang-github-go-openapi-jsonpointer-dev
	,golang-github-go-openapi-jsonreference-dev
	,golang-github-elazarl-goproxy-dev
	,golang-github-elazarl-go-bindata-assetfs-dev
	,golang-gopkg-natefinch-lumberjack.v2-dev
	,golang-github-jonboulle-clockwork-dev
	,golang-github-pborman-uuid-dev
	,golang-github-kardianos-osext-dev
	,golang-github-cpuguy83-go-md2man-dev
	,golang-github-mxk-go-flowrate-dev
	,golang-ginkgo-dev
	,golang-gomega-dev
	,golang-github-evanphx-json-patch-dev
	,golang-github-cpuguy83-go-md2man-dev
	,golang-github-mesos-mesos-go-dev
	,golang-github-jmespath-go-jmespath-dev
	,golang-github-xyproto-simpleredis-dev
	,golang-github-jteeuwen-go-bindata-dev
	,golang-github-fsnotify-fsnotify-dev
	,golang-github-stretchr-testify-dev
	,golang-glog-dev
	,golang-github-azure-go-ansiterm-dev
	,golang-github-xiang90-probing-dev
	,golang-github-beorn7-perks-dev
	,golang-github-hawkular-hawkular-client-go-dev
	,golang-github-kr-fs-dev
	,golang-github-kr-pty-dev
	,golang-github-mitchellh-mapstructure-dev
	,golang-github-mitchellh-go-wordwrap-dev
	,golang-gopkg-gcfg.v1-dev
	,golang-github-mvdan-xurls-dev
	,golang-github-puerkitobio-purell-dev
	,golang-go-zfs-dev
	,golang-github-asaskevich-govalidator-dev
	,golang-github-ghodss-yaml-dev
	,golang-github-hashicorp-golang-lru-dev
	,golang-github-hashicorp-hcl-dev
	,golang-golang-x-oauth2-dev
	,golang-golang-x-oauth2-google-dev
	,golang-github-pelletier-go-buffruneio-dev
	,golang-github-pelletier-go-toml-dev
	,golang-github-mailru-easyjson-dev
	,golang-github-vishvananda-netlink-dev
	,golang-github-inconshreveable-mousetrap-dev
	,golang-github-mreiferson-go-httpclient-dev
	,golang-github-howeyc-gopass-dev
	,golang-golang-x-crypto-dev
	,golang-golang-x-sys-dev
	,golang-golang-x-text-dev
	,golang-golang-x-net-dev
	,golang-golang-x-exp-dev
	,golang-github-seccomp-libseccomp-golang-dev
	,golang-github-shurcool-sanitized-anchor-name-dev
	,golang-github-abbot-go-http-auth-dev
	,golang-github-stretchr-objx-dev
	,golang-github-pmezard-go-difflib-dev
	,golang-github-codegangsta-negroni-dev
	,golang-github-samuel-go-zookeeper-dev
	,golang-github-go-ini-ini-dev
	,golang-github-golang-mock-dev
	,golang-github-golang-groupcache-dev
	,golang-github-boltdb-bolt-dev
	,golang-github-russross-blackfriday-dev
	,golang-github-google-gofuzz-dev
	,golang-github-coreos-go-oidc-dev
	,golang-github-magiconair-properties-dev
	,golang-github-sirupsen-logrus-dev
	,golang-github-pkg-errors-dev
	,golang-github-pkg-sftp-dev
	,golang-github-go-openapi-loads-dev
	,golang-github-go-openapi-analysis-dev
	,golang-github-go-openapi-strfmt-dev
	,golang-github-go-openapi-runtime-dev
	,golang-github-go-openapi-errors-dev
	,golang-github-go-openapi-validate-dev
	,golang-github-google-btree-dev
	,golang-github-daviddengcn-go-colortext-dev
	,golang-github-garyburd-redigo-dev
	,golang-github-miekg-dns-dev
	,golang-github-gorilla-context-dev
	,golang-github-gorilla-mux-dev
	,golang-github-lpabon-godbc-dev
	,golang-github-xanzy-go-cloudstack-dev
	,golang-github-makenowjust-heredoc-dev
	,golang-github-docker-spdystream-dev
	,golang-gocapability-dev
	,golang-github-kubernetes-gengo-dev
	,golang-github-robfig-cron-dev
	,golang-github-kubernetes-heapster-dev
	,golang-github-cloudflare-cfssl-dev
	,golang-github-google-certificate-transparency-dev
	,golang-github-vmware-photon-controller-go-sdk-dev
	,golang-github-quobyte-api-dev
	,golang-github-renstrom-dedent-dev
	,golang-github-exponent-io-jsonpath-dev
	,golang-github-docker-go-connections-dev
	,golang-github-docker-go-units-dev
	,golang-github-juju-ratelimit-dev
	,golang-github-ugorji-go-codec-dev
	,golang-github-rackspace-gophercloud-dev
	,golang-protobuf-extensions-dev
	,golang-github-influxdb-influxdb-dev
	,golang-github-coreos-pkg-dev
	,golang-go-semver-dev
	,golang-github-prometheus-client-golang-dev
	,golang-github-prometheus-client-model-dev
	,golang-github-prometheus-common-dev
	,golang-procfs-dev
	,golang-speter-go-exp-math-dec-inf-dev
	,golang-gopkg-yaml.v2-dev
	,golang-github-opennota-urlesc-dev
	,golang-github-vmware-govmomi-dev (>= 0.8.0+git20160719.9.b5ee639~)
	,golang-github-google-cadvisor-dev (>= 0.25.0~)
	,golang-github-imdario-mergo-dev
	,golang-github-docker-engine-api-dev
	,golang-github-coreos-go-systemd-dev
	,golang-github-opencontainers-runc-dev
	,golang-google-cloud-compute-metadata-dev
	,golang-google-appengine-dev
	,golang-github-appc-spec-dev
	,golang-etcd-server-dev
	,golang-github-emicklei-go-restful-dev
	,golang-dbus-dev
	,golang-github-grpc-ecosystem-grpc-gateway-dev
	,golang-github-aws-aws-sdk-go-dev
	,golang-google-api-dev
	,golang-github-skynetservices-skydns-dev
Standards-Version: 3.9.8
Homepage: http://kubernetes.io/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/kubernetes.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/kubernetes.git

Package: kubernetes-client
Provides: kubernetes-utils
Architecture: amd64 i386 armel armhf arm64 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ${misc:Recommends}
Built-Using: ${misc:Built-Using}
Description: Kubernetes client tools
 Kubernetes command line utilities:
  * kubectl -- Kubernetes cluster management utility

Package: kubernetes-master
Architecture: amd64 i386 armel armhf arm64 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
    ,adduser
    ,lsb-base
Recommends: ${misc:Recommends}, kubernetes-client
#            ca-certificates,
#            cgroupfs-mount | cgroup-lite,
Built-Using: ${misc:Built-Using}
Description: Kubernetes services for master host
 Container Cluster Manager from Google. Kubernetes is an open source system
 for managing containerized applications across multiple hosts, providing
 basic mechanisms for deployment, maintenance, and scaling of applications.
 .
 Linux kernel version 3.8 or above is required for proper operation of the
 daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides "kube-apiserver", "kube-controller-manager" and
 "kube-scheduler" daemons.

Package: kubernetes-node
Provides: cadvisor
Architecture: amd64 i386 armel armhf arm64 s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
    ,adduser
    ,docker.io
    ,lsb-base
#   ,socat
Recommends: ${misc:Recommends}, kubernetes-client
#            cgroupfs-mount | cgroup-lite,
Built-Using: ${misc:Built-Using}
Description: Kubernetes services for node host
 Container Cluster Manager from Google. Kubernetes is an open source system
 for managing containerized applications across multiple hosts, providing
 basic mechanisms for deployment, maintenance, and scaling of applications.
 .
 Linux kernel version 3.8 or above is required for proper operation of the
 daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides "kube-proxy" and "kubelet" daemons.

#Package: kubernetes-doc
#Section: doc
#Architecture: all
#Depends: ${misc:Depends}
#Description: examples of how to run applications with Kubernetes
# Kubernetes Documentation:
#  * The User's guide is for anyone who wants to run programs and
#    services on an existing Kubernetes cluster.
#  * The "Cluster Admin's guide" is for anyone setting up a Kubernetes
#    cluster or administering it.
#  * The Developer guide describing how to write programs that access the
#    Kubernetes API, write plugins or extensions, or modify the core code of
#    Kubernetes.
#  * The Kubectl Command Line Interface is a detailed reference on the
#    `kubectl` CLI.
#  * The API object documentation is a detailed description of all fields
#    found in core API objects.
#  * An overview of the "Design of Kubernetes".
#  * Example files and walkthroughs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export GOMAXPROCS=1
export DH_GOPKG := k8s.io/kubernetes
export DH_GOLANG_INSTALL_ALL := 1

export DH_GOLANG_EXCLUDES := \
    contrib \
    kubernetes/examples \
    test/component/scheduler/perf \
    test/e2e \
    test/integration \
    hack/boilerplate/test \
    pkg/runtime/serializer/recognizer/testing

%:
	dh $@ --buildsystem=golang --builddirectory=_build \
              --with golang,systemd,bash_completion \
              --parallel

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
	-find vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
	cp -v third_party/swagger-ui/swagger-ui.js third_party/swagger-ui/swagger-ui.min.js
	cp -v debian/missing-sources/backbone.js third_party/swagger-ui/lib/backbone-min.js
	cp -v debian/missing-sources/handlebars.runtime-v2.0.0.js third_party/swagger-ui/lib/handlebars-2.0.0.js
	cp -v debian/missing-sources/highlight.js third_party/swagger-ui/lib/highlight.7.3.pack.js
	cp -v debian/missing-sources/jquery.js third_party/swagger-ui/lib/jquery-1.8.0.min.js
	cp -v debian/missing-sources/jquery.ba-bbq.js third_party/swagger-ui/lib/jquery.ba-bbq.min.js
	cp -v debian/missing-sources/jquery.slideto.js third_party/swagger-ui/lib/jquery.slideto.min.js
	cp -v debian/missing-sources/underscore.js third_party/swagger-ui/lib/underscore-min.js
	hack/build-ui.sh
	(cd test/e2e/framework && GOPATH=$(PWD)/_build ../../../hack/generate-bindata.sh)
	mkdir -pv _build/src/k8s.io/kubernetes
	cp -rv staging/src/k8s.io _build/src
	cp -rv staging/src/k8s.io/client-go/_vendor/* _build/src
	dh_auto_configure
	# Don't compile a second copy of staged client
	rm -rf _build/src/k8s.io/kubernetes/staging

override_dh_auto_build:
	dh_auto_build
	## Build man pages:
	mkdir -p _build/docs/man/man1
	for module in kube-apiserver kube-controller-manager kube-proxy kube-scheduler kubelet kubectl; do \
	  (cd _build && bin/genman docs/man/man1 $$module); \
	done
	debian/man/md2man.sh _build

override_dh_installinit:
	dh_installinit -p kubernetes-master --name=kube-apiserver
	dh_installinit -p kubernetes-master --name=kube-controller-manager
	dh_installinit -p kubernetes-master --name=kube-scheduler
	dh_installinit -p kubernetes-node --name=kube-proxy
	dh_installinit -p kubernetes-node --name=kubelet
	dh_installinit --no-start

override_dh_systemd_start:
	dh_systemd_start --no-start

override_dh_systemd_enable:
	dh_systemd_enable --no-enable

override_dh_auto_test:
	-dh_auto_test
ifeq (,$(filter nocheck,$(DEB_output_OPTIONS)))
	## test for #825753 (github.com/imdario/mergo compatibility):
	./_build/bin/kubectl version --server="http://localhost:7777" 2>&1 >>/dev/null | grep -q 7777
endif

## http://wiki.debian.org/onlyjob/get-orig-source
PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s*([\d\.]+)}')
.PHONY: get-orig-source
get-orig-source:
	@echo "# Downloading..."
	uscan --noconf --verbose --rename --repack --compression xz --destdir=$(CURDIR) \
              --check-dirname-level=0 --force-download --download-version $(VER) $(PKD)

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=\
repacksuffix=+dfsg,\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\-(\d+)\Z}{.$1},\
 https://github.com/kubernetes/kubernetes/releases \
 .*/archive/v?(\d[\d\.]+)\.tar\.gz

#opts=\
#repacksuffix=+dfsg,\
#dversionmangle=s{\+dfsg\d*}{},\
#uversionmangle=s{\-(\d+)\Z}{.$1},\
# https://github.com/kubernetes/kubernetes/releases?after=v1.0.7 \
# .*/archive/v?(\d[\d\.]+)\.tar\.gz

## kubernetes 1.7.7+dfsg

=== build/root/Makefile ===
# Copyright 2016 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

DBG_MAKEFILE ?=
ifeq ($(DBG_MAKEFILE),1)
    $(warning ***** starting Makefile for goal(s) "$(MAKECMDGOALS)")
    $(warning ***** $(shell date))
else
    # If we're not debugging the Makefile, don't echo recipes.
    MAKEFLAGS += -s
endif


# Old-skool build tools.
#
# Commonly used targets (see each target for more information):
#   all: Build code.
#   test: Run tests.
#   clean: Clean up.

# It's necessary to set this because some environments don't link sh -> bash.
SHELL := /bin/bash

# We don't need make's built-in rules.
MAKEFLAGS += --no-builtin-rules
.SUFFIXES:

# Constants used throughout.
.EXPORT_ALL_VARIABLES:
OUT_DIR ?= _output
BIN_DIR := $(OUT_DIR)/bin
PRJ_SRC_PATH := k8s.io/kubernetes
GENERATED_FILE_PREFIX := zz_generated.

# Metadata for driving the build lives here.
META_DIR := .make

# Our build flags.
# TODO(thockin): it would be nice to just use the native flags.  Can we EOL
#                these "wrapper" flags?
KUBE_GOFLAGS := $(GOFLAGS)
KUBE_GOLDFLAGS := $(GOLDFLAGS)
KUBE_GOGCFLAGS = $(GOGCFLAGS)

# Extra options for the release or quick-release options:
KUBE_RELEASE_RUN_TESTS := $(KUBE_RELEASE_RUN_TESTS) 
KUBE_FASTBUILD := $(KUBE_FASTBUILD)

# This controls the verbosity of the build.  Higher numbers mean more output.
KUBE_VERBOSE ?= 1

define ALL_HELP_INFO
# Build code.
#
# Args:
#   WHAT: Directory names to build.  If any of these directories has a 'main'
#     package, the build will produce executable files under $(OUT_DIR)/go/bin.
#     If not specified, "everything" will be built.
#   GOFLAGS: Extra flags to pass to 'go' when building.
#   GOLDFLAGS: Extra linking flags passed to 'go' when building.
#   GOGCFLAGS: Additional go compile flags passed to 'go' when building.
#
# Example:
#   make
#   make all
#   make all WHAT=cmd/kubelet GOFLAGS=-v
#   make all GOGCFLAGS="-N -l"
#     Note: Use the -N -l options to disable compiler optimizations an inlining.
#           Using these build options allows you to subsequently use source
#           debugging tools like delve.
endef
.PHONY: all
ifeq ($(PRINT_HELP),y)
all:
	@echo "$$ALL_HELP_INFO"
else
all: generated_files
	hack/make-rules/build.sh $(WHAT)
endif

define GINKGO_HELP_INFO
# Build ginkgo
#
# Example:
# make ginkgo
endef
.PHONY: ginkgo
ifeq ($(PRINT_HELP),y)
ginkgo:
	@echo "$$GINKGO_HELP_INFO"
else
ginkgo:
	hack/make-rules/build.sh vendor/github.com/onsi/ginkgo/ginkgo
endif

define VERIFY_HELP_INFO
# Runs all the presubmission verifications.
#
# Args:
#   BRANCH: Branch to be passed to verify-godeps.sh script.
#
# Example:
#   make verify
#   make verify BRANCH=branch_x
endef
.PHONY: verify
ifeq ($(PRINT_HELP),y)
verify:
	@echo "$$VERIFY_HELP_INFO"
else
verify: verify_generated_files
	KUBE_VERIFY_GIT_BRANCH=$(BRANCH) hack/make-rules/verify.sh -v
	hack/make-rules/vet.sh
endif

define UPDATE_HELP_INFO
# Runs all the generated updates.
#
# Example:
# make update
endef
.PHONY: update
ifeq ($(PRINT_HELP),y)
update:
	@echo "$$UPDATE_HELP_INFO"
else
update:
	hack/update-all.sh
endif

define CHECK_TEST_HELP_INFO
# Build and run tests.
#
# Args:
#   WHAT: Directory names to test.  All *_test.go files under these
#     directories will be run.  If not specified, "everything" will be tested.
#   TESTS: Same as WHAT.
#   GOFLAGS: Extra flags to pass to 'go' when building.
#   GOLDFLAGS: Extra linking flags to pass to 'go' when building.
#   GOGCFLAGS: Additional go compile flags passed to 'go' when building.
#
# Example:
#   make check
#   make test
#   make check WHAT=./pkg/kubelet GOFLAGS=-v
endef
.PHONY: check test
ifeq ($(PRINT_HELP),y)
check test:
	@echo "$$CHECK_TEST_HELP_INFO"
else
check test: generated_files
	hack/make-rules/test.sh $(WHAT) $(TESTS)
endif

define TEST_IT_HELP_INFO
# Build and run integration tests.
#
# Args:
#   WHAT: Directory names to test.  All *_test.go files under these
#     directories will be run.  If not specified, "everything" will be tested.
#
# Example:
#   make test-integration
endef
.PHONY: test-integration
ifeq ($(PRINT_HELP),y)
test-integration:
	@echo "$$TEST_IT_HELP_INFO"
else
test-integration: generated_files
	hack/make-rules/test-integration.sh $(WHAT)
endif

define TEST_E2E_HELP_INFO
# Build and run end-to-end tests.
#
# Example:
#   make test-e2e
endef
.PHONY: test-e2e
ifeq ($(PRINT_HELP),y)
test-e2e:
	@echo "$$TEST_E2E_HELP_INFO"
else
test-e2e: ginkgo generated_files
	go run hack/e2e.go -- -v --build --up --test --down
endif

define TEST_E2E_NODE_HELP_INFO
# Build and run node end-to-end tests.
#
# Args:
#  FOCUS: Regexp that matches the tests to be run.  Defaults to "".
#  SKIP: Regexp that matches the tests that needs to be skipped.  Defaults
#    to "".
#  RUN_UNTIL_FAILURE: If true, pass --untilItFails to ginkgo so tests are run
#    repeatedly until they fail.  Defaults to false.
#  REMOTE: If true, run the tests on a remote host instance on GCE.  Defaults
#    to false.
#  IMAGES: For REMOTE=true only.  Comma delimited list of images for creating
#    remote hosts to run tests against.  Defaults to a recent image.
#  LIST_IMAGES: If true, don't run tests.  Just output the list of available
#    images for testing.  Defaults to false.
#  HOSTS: For REMOTE=true only.  Comma delimited list of running gce hosts to
#    run tests against.  Defaults to "".
#  DELETE_INSTANCES: For REMOTE=true only.  Delete any instances created as
#    part of this test run.  Defaults to false.
#  ARTIFACTS: For REMOTE=true only.  Local directory to scp test artifacts into
#    from the remote hosts.  Defaults to "/tmp/_artifacts".
#  REPORT: For REMOTE=false only.  Local directory to write juntil xml results
#    to.  Defaults to "/tmp/".
#  CLEANUP: For REMOTE=true only.  If false, do not stop processes or delete
#    test files on remote hosts.  Defaults to true.
#  IMAGE_PROJECT: For REMOTE=true only.  Project containing images provided to
#  IMAGES.  Defaults to "kubernetes-node-e2e-images".
#  INSTANCE_PREFIX: For REMOTE=true only.  Instances created from images will
#    have the name "${INSTANCE_PREFIX}-${IMAGE_NAME}".  Defaults to "test".
#  INSTANCE_METADATA: For REMOTE=true and running on GCE only.
#  GUBERNATOR: For REMOTE=true only. Produce link to Gubernator to view logs.
#	 Defaults to false.
#  PARALLELISM: The number of gingko nodes to run.  Defaults to 8.
#  RUNTIME: Container runtime to use (eg. docker, rkt, remote).
#    Defaults to "docker".
#  CONTAINER_RUNTIME_ENDPOINT: remote container endpoint to connect to.
#   Used when RUNTIME is set to "remote".
#  IMAGE_SERVICE_ENDPOINT: remote image endpoint to connect to, to prepull images.
#   Used when RUNTIME is set to "remote".
#  IMAGE_CONFIG_FILE: path to a file containing image configuration.
#  SYSTEM_SPEC_NAME: The name of the system spec to be used for validating the
#    image in the node conformance test. The specs are located at
#    test/e2e_node/system/specs/. For example, "SYSTEM_SPEC_NAME=gke" will use
#    the spec at test/e2e_node/system/specs/gke.yaml. If unspecified, the
#    default built-in spec (system.DefaultSpec) will be used.
#
# Example:
#   make test-e2e-node FOCUS=Kubelet SKIP=container
#   make test-e2e-node REMOTE=true DELETE_INSTANCES=true
#   make test-e2e-node TEST_ARGS='--kubelet-flags="--cgroups-per-qos=true"'
# Build and run tests.
endef
.PHONY: test-e2e-node
ifeq ($(PRINT_HELP),y)
test-e2e-node:
	@echo "$$TEST_E2E_NODE_HELP_INFO"
else
test-e2e-node: ginkgo generated_files
	hack/make-rules/test-e2e-node.sh
endif

define TEST_CMD_HELP_INFO
# Build and run cmdline tests.
#
# Example:
#   make test-cmd
endef
.PHONY: test-cmd
ifeq ($(PRINT_HELP),y)
test-cmd:
	@echo "$$TEST_CMD_HELP_INFO"
else
test-cmd: generated_files
	hack/make-rules/test-kubeadm-cmd.sh
	hack/make-rules/test-cmd.sh
	hack/make-rules/test-federation-cmd.sh
endif

define CLEAN_HELP_INFO
# Remove all build artifacts.
#
# Example:
#   make clean
#
# TODO(thockin): call clean_generated when we stop committing generated code.
endef
.PHONY: clean
ifeq ($(PRINT_HELP),y)
clean:
	@echo "$$CLEAN_HELP_INFO"
else
clean: clean_meta
	build/make-clean.sh
	rm -rf $(OUT_DIR)
	rm -rf Godeps/_workspace # Just until we are sure it is gone
	# TODO(thockin): Remove this when we call clean_generated.
	rm -f pkg/generated/openapi/zz_generated.openapi.go
endif

define CLEAN_META_HELP_INFO
# Remove make-related metadata files.
#
# Example:
#   make clean_meta
endef
.PHONY: clean_meta
ifeq ($(PRINT_HELP),y)
clean_meta:
	@echo "$$CLEAN_META_HELP_INFO"
else
clean_meta:
	rm -rf $(META_DIR)
endif

define CLEAN_GENERATED_HELP_INFO
# Remove all auto-generated artifacts. Generated artifacts in staging folder should not be removed as they are not
# generated using generated_files.
#
# Example:
#   make clean_generated
endef
.PHONY: clean_generated
ifeq ($(PRINT_HELP),y)
clean_generated:
	@echo "$$CLEAN_GENERATED_HELP_INFO"
else
clean_generated:
	find . -type f -name $(GENERATED_FILE_PREFIX)\* | grep -v "[.]/staging/.*" | xargs rm -f
endif

define VET_HELP_INFO
# Run 'go vet'.
#
# Args:
#   WHAT: Directory names to vet.  All *.go files under these
#     directories will be vetted.  If not specified, "everything" will be
#     vetted.
#
# Example:
#   make vet
#   make vet WHAT=./pkg/kubelet
endef
.PHONY: vet
ifeq ($(PRINT_HELP),y)
vet:
	@echo "$$VET_HELP_INFO"
else
vet:
	hack/make-rules/vet.sh $(WHAT)
endif

define RELEASE_HELP_INFO
# Build a release
#
# Example:
#   make release
endef
.PHONY: release
ifeq ($(PRINT_HELP),y)
release:
	@echo "$$RELEASE_HELP_INFO"
else
release:
	build/release.sh
endif

define RELEASE_SKIP_TESTS_HELP_INFO
# Build a release, but skip tests
# 
# Args:
#   KUBE_RELEASE_RUN_TESTS: Whether to run tests. Set to 'y' to run tests anyways.
#   KUBE_FASTBUILD: Whether to cross-compile for other architectures. Set to 'true' to do so.
#
# Example:
#   make release-skip-tests
#   make quick-release
endef
.PHONY: release-skip-tests quick-release
ifeq ($(PRINT_HELP),y)
release-skip-tests quick-release:
	@echo "$$RELEASE_SKIP_TESTS_HELP_INFO"
else
release-skip-tests quick-release: KUBE_RELEASE_RUN_TESTS = n
release-skip-tests quick-release: KUBE_FASTBUILD = true
release-skip-tests quick-release:
	build/release.sh
endif

define CROSS_HELP_INFO
# Cross-compile for all platforms
#
# Example:
#   make cross
endef
.PHONY: cross
ifeq ($(PRINT_HELP),y)
cross:
	@echo "$$CROSS_HELP_INFO"
else
cross:
	hack/make-rules/cross.sh
endif

define CMD_HELP_INFO
# Add rules for all directories in cmd/
#
# Example:
#   make kubectl kube-proxy
endef
#TODO: make EXCLUDE_TARGET auto-generated when there are other files in cmd/
#TODO: should we exclude the target "libs" but include "cmd/libs/go2idl/*"?
EXCLUDE_TARGET=OWNERS
.PHONY: $(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/))))
ifeq ($(PRINT_HELP),y)
$(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/)))):
	@echo "$$CMD_HELP_INFO"
else
$(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/)))): generated_files
	hack/make-rules/build.sh cmd/$@
endif

define PLUGIN_CMD_HELP_INFO
# Add rules for all directories in plugin/cmd/
#
# Example:
#   make kube-scheduler
endef
.PHONY: $(notdir $(abspath $(wildcard plugin/cmd/*/)))
ifeq ($(PRINT_HELP),y)
$(notdir $(abspath $(wildcard plugin/cmd/*/))):
	@echo "$$PLUGIN_CMD_HELP_INFO"
else
$(notdir $(abspath $(wildcard plugin/cmd/*/))): generated_files
	hack/make-rules/build.sh plugin/cmd/$@
endif

define FED_CMD_HELP_INFO

## kubernetes 1.7.16+dfsg

=== build/root/Makefile ===
--- 
+++ 
@@ -195,7 +195,7 @@
 	@echo "$$TEST_E2E_HELP_INFO"
 else
 test-e2e: ginkgo generated_files
-	go run hack/e2e.go -- -v --build --up --test --down
+	go run hack/e2e.go -- --build --up --test --down
 endif
 
 define TEST_E2E_NODE_HELP_INFO
@@ -351,17 +351,23 @@
 
 define RELEASE_HELP_INFO
 # Build a release
+# Use the 'release-in-a-container' target to build the release when already in
+# a container vs. creating a new container to build in using the 'release'
+# target.  Useful for running in GCB.
 #
 # Example:
 #   make release
-endef
-.PHONY: release
-ifeq ($(PRINT_HELP),y)
-release:
+#   make release-in-a-container
+endef
+.PHONY: release release-in-a-container
+ifeq ($(PRINT_HELP),y)
+release release-in-a-container:
 	@echo "$$RELEASE_HELP_INFO"
 else
 release:
 	build/release.sh
+release-in-a-container:
+	build/release-in-a-container.sh
 endif
 
 define RELEASE_SKIP_TESTS_HELP_INFO
@@ -386,52 +392,40 @@
 	build/release.sh
 endif
 
+define PACKAGE_HELP_INFO
+# Package tarballs
+# Use the 'package-tarballs' target to run the final packaging steps of
+# a release.
+#
+# Example:
+#   make package-tarballs
+endef
+.PHONY: package package-tarballs
+ifeq ($(PRINT_HELP),y)
+package package-tarballs:
+	@echo "$$PACKAGE_HELP_INFO"
+else
+package package-tarballs:
+	build/package-tarballs.sh
+endif
+
 define CROSS_HELP_INFO
 # Cross-compile for all platforms
+# Use the 'cross-in-a-container' target to cross build when already in
+# a container vs. creating a new container to build from (build-image)
+# Useful for running in GCB.
 #
 # Example:
 #   make cross
-endef
-.PHONY: cross
-ifeq ($(PRINT_HELP),y)
-cross:
+#   make cross-in-a-container
+endef
+.PHONY: cross cross-in-a-container
+ifeq ($(PRINT_HELP),y)
+cross cross-in-a-container:
 	@echo "$$CROSS_HELP_INFO"
 else
 cross:
 	hack/make-rules/cross.sh
-endif
-
-define CMD_HELP_INFO
-# Add rules for all directories in cmd/
-#
-# Example:
-#   make kubectl kube-proxy
-endef
-#TODO: make EXCLUDE_TARGET auto-generated when there are other files in cmd/
-#TODO: should we exclude the target "libs" but include "cmd/libs/go2idl/*"?
-EXCLUDE_TARGET=OWNERS
-.PHONY: $(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/))))
-ifeq ($(PRINT_HELP),y)
-$(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/)))):
-	@echo "$$CMD_HELP_INFO"
-else
-$(filter-out %$(EXCLUDE_TARGET),$(notdir $(abspath $(wildcard cmd/*/)))): generated_files
-	hack/make-rules/build.sh cmd/$@
-endif
-
-define PLUGIN_CMD_HELP_INFO
-# Add rules for all directories in plugin/cmd/
-#
-# Example:
-#   make kube-scheduler
-endef
-.PHONY: $(notdir $(abspath $(wildcard plugin/cmd/*/)))
-ifeq ($(PRINT_HELP),y)
-$(notdir $(abspath $(wildcard plugin/cmd/*/))):
-	@echo "$$PLUGIN_CMD_HELP_INFO"
-else
-$(notdir $(abspath $(wildcard plugin/cmd/*/))): generated_files
-	hack/make-rules/build.sh plugin/cmd/$@
-endif
-
-define FED_CMD_HELP_INFO
+cross-in-a-container: KUBE_OUTPUT_SUBPATH = $(OUT_DIR)/dockerized
+cross-in-a-container:
+ifeq (,$(wildcard /.dockerenv))

=== cluster/images/hyperkube/Makefile ===
# Copyright 2016 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Build the hyperkube image.
#
# Usage:
#   [ARCH=amd64] [REGISTRY="gcr.io/google_containers"] make (build|push) VERSION={some_released_version_of_kubernetes}

REGISTRY?=gcr.io/google_containers
ARCH?=amd64
OUT_DIR?=_output
TEMP_DIR:=$(shell mktemp -d -t hyperkubeXXXXXX)
CNI_RELEASE=0799f5732f2a11b329d9e3d51b9c8f2e3759f2ff
CACHEBUST?=1
QEMUVERSION=v2.7.0

UNAME_S:=$(shell uname -s)
ifeq ($(UNAME_S),Darwin)
	SED_CMD?=sed -i ""
endif
ifeq ($(UNAME_S),Linux)
	SED_CMD?=sed -i
endif

ifeq ($(ARCH),amd64)
	BASEIMAGE?=debian:jessie
endif
ifeq ($(ARCH),arm)
	BASEIMAGE?=armhf/debian:jessie
	QEMUARCH=arm
endif
ifeq ($(ARCH),arm64)
	BASEIMAGE?=aarch64/debian:jessie
	QEMUARCH=aarch64
endif
ifeq ($(ARCH),ppc64le)
	BASEIMAGE?=ppc64le/debian:jessie
	QEMUARCH=ppc64le
endif
ifeq ($(ARCH),s390x)
	BASEIMAGE?=s390x/debian:jessie
	QEMUARCH=s390x
endif

all: build

build:

ifndef VERSION
    $(error VERSION is undefined)
endif
	cp -r ./* ${TEMP_DIR}
	mkdir -p ${TEMP_DIR}/cni-bin

	cp ../../../$(OUT_DIR)/dockerized/bin/linux/${ARCH}/hyperkube ${TEMP_DIR}
	chmod a+rx ${TEMP_DIR}/hyperkube

	cd ${TEMP_DIR} && sed -i.back "s|ARCH|${QEMUARCH}|g" Dockerfile
	cd ${TEMP_DIR} && sed -i.back "s|BASEIMAGE|${BASEIMAGE}|g" Dockerfile
ifeq ($(CACHEBUST),1)
	cd ${TEMP_DIR} && sed -i.back "s|CACHEBUST|$(shell uuidgen)|g" Dockerfile
endif

ifeq ($(ARCH),amd64)
	# When building "normally" for amd64, remove the whole line, it has no part in the amd64 image
	cd ${TEMP_DIR} && ${SED_CMD} "/CROSS_BUILD_/d" Dockerfile
else
	cd ${TEMP_DIR} && ${SED_CMD} "s/CROSS_BUILD_//g" Dockerfile

	# When cross-building, only the placeholder "CROSS_BUILD_" should be removed
	# Register /usr/bin/qemu-ARCH-static as the handler for ARM binaries in the kernel
	docker run --rm --privileged multiarch/qemu-user-static:register --reset
	curl -sSL --retry 5 https://github.com/multiarch/qemu-user-static/releases/download/$(QEMUVERSION)/x86_64_qemu-${QEMUARCH}-static.tar.gz | tar -xz -C ${TEMP_DIR}
endif
	# Download CNI
	curl -sSL --retry 5 https://storage.googleapis.com/kubernetes-release/network-plugins/cni-${ARCH}-${CNI_RELEASE}.tar.gz | tar -xz -C ${TEMP_DIR}/cni-bin

	docker build --pull -t ${REGISTRY}/hyperkube-${ARCH}:${VERSION} ${TEMP_DIR}
	rm -rf "${TEMP_DIR}"

push: build
	gcloud docker -- push ${REGISTRY}/hyperkube-${ARCH}:${VERSION}
ifeq ($(ARCH),amd64)
	docker rmi ${REGISTRY}/hyperkube:${VERSION} 2>/dev/null || true
	docker tag ${REGISTRY}/hyperkube-${ARCH}:${VERSION} ${REGISTRY}/hyperkube:${VERSION}
	gcloud docker -- push ${REGISTRY}/hyperkube:${VERSION}
endif

.PHONY: all

=== test/e2e_node/conformance/build/Makefile ===
# Copyright 2016 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Build the node-test image.
#
# Usage:
#   [ARCH=amd64] [REGISTRY="gcr.io/google_containers"] [BIN_DIR="../../../../_output/bin"] make (build|push) VERSION={some_version_number e.g. 0.1}

# SYSTEM_SPEC_NAME is the name of the system spec used for the node conformance
# test. The specs are expected to be in SYSTEM_SPEC_DIR.
SYSTEM_SPEC_NAME?=
SYSTEM_SPEC_DIR?=../../system/specs

# TODO(random-liu): Add this into release progress.
REGISTRY?=gcr.io/google_containers
ARCH?=amd64
# BIN_DIR is the directory to find binaries, overwrite with ../../../../_output/bin
# for local development.
BIN_DIR?=../../../../_output/dockerized/bin/linux/${ARCH}
TEMP_DIR:=$(shell mktemp -d)

BASEIMAGE_amd64=debian:jessie
BASEIMAGE_arm=armhf/debian:jessie
BASEIMAGE_arm64=aarch64/debian:jessie
BASEIMAGE_ppc64le=ppc64le/debian:jessie

BASEIMAGE?=${BASEIMAGE_${ARCH}}

IMAGE_NAME:=${REGISTRY}/node-test
COPY_SYSTEM_SPEC_FILE=
SYSTEM_SPEC_FILE_PATH=
ifneq ($(strip $(SYSTEM_SPEC_NAME)),)
    IMAGE_NAME:=${IMAGE_NAME}-${SYSTEM_SPEC_NAME}
    COPY_SYSTEM_SPEC_FILE="'COPY system-spec.yaml /usr/local/etc/'"
    SYSTEM_SPEC_FILE_PATH="'/usr/local/etc/system-spec.yaml'"
endif

all: build

build:

ifndef VERSION
    $(error VERSION is undefined)
endif
	cp -r ./* ${TEMP_DIR}

	cp ${BIN_DIR}/ginkgo ${TEMP_DIR}
	cp ${BIN_DIR}/e2e_node.test ${TEMP_DIR}
ifneq ($(strip $(SYSTEM_SPEC_NAME)),)
	cp ${SYSTEM_SPEC_DIR}/${SYSTEM_SPEC_NAME}.yaml ${TEMP_DIR}/system-spec.yaml
endif

	cd ${TEMP_DIR} && sed -i.back \
	    "s|BASEIMAGE|${BASEIMAGE}|g;\
	     s|COPY_SYSTEM_SPEC_FILE|${COPY_SYSTEM_SPEC_FILE}|g;\
	     s|SYSTEM_SPEC_NAME|${SYSTEM_SPEC_NAME}|g;\
	     s|SYSTEM_SPEC_FILE_PATH|${SYSTEM_SPEC_FILE_PATH}|g" Dockerfile

	# Make scripts executable before they are copied into the Docker image. If we make them executable later, in another layer
	# they'll take up twice the space because the new executable binary differs from the old one, but everything is cached in layers.
	cd ${TEMP_DIR} && chmod a+rx \
		e2e_node.test \
		ginkgo

	docker build --pull -t ${IMAGE_NAME}-${ARCH}:${VERSION} ${TEMP_DIR}

push: build
	gcloud docker -- push ${IMAGE_NAME}-${ARCH}:${VERSION}
ifeq ($(ARCH),amd64)
	docker tag ${IMAGE_NAME}-${ARCH}:${VERSION} ${IMAGE_NAME}:${VERSION}
	gcloud docker -- push ${IMAGE_NAME}:${VERSION}
endif

.PHONY: all
